/*
*
*
*/

#include "hconp000.ch"

FUNCTION main( ... )
IF ! l3w_fSetsys( Hb_AParams() )
 QUIT
ENDIF

z999_main()

DBUNLOCKALL()
DBCLOSEALL()
RETURN NIL

/*
*    funzione principale
*/
STATIC FUNCTION z999_main()
z999_cProcName := "hconz999"
z999_proctitl := "Men principale"

l3w_fConf("Application", "Name", "hconp000")
l3w_fConf("Application", "Title","Gestione Contatti")
l3w_fConf("Application", "Version",  "0.0.1")

SET NAVIGATION EXTENDED
DEFINE WINDOW z999win ;
 AT 0,0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fConf("Application", "Title") + " (" + l3w_fConf("Application", "Version") + ") :: " + z999_proctitl + " (" + z999_cProcName + ")" ;
 WINDOWTYPE MAIN ;
 ICON 'L3W_L3WICO' ;
 ON INIT z999_login() ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE MAIN MENU
 DEFINE POPUP '&File'
  MENUITEM 'e&Xit' ACTION z999_exit()
 END POPUP
 DEFINE POPUP '&Create'
  MENUITEM '&Contacts'   ACTION z999_subjec('D')
  MENUITEM '&Mail List'  ACTION z999_mailer('D')
  MENUITEM '&Typologies' ACTION z999_typolo('D')
  MENUITEM '&Languages'  ACTION z999_lingue('D')
  MENUITEM 'c&Ategories' ACTION z999_catego('D')
  MENUITEM 'cou&Nters'   ACTION z999_progre('D')
  SEPARATOR
  MENUITEM 'All'   ACTION z999_all('D')
 END POPUP
 DEFINE POPUP '&Reindex'
  MENUITEM '&Contacts'   ACTION z999_subjec('I')
  MENUITEM '&Mail List'  ACTION z999_mailer('I')
  MENUITEM '&Typologies' ACTION z999_typolo('I')
  MENUITEM '&Languages'  ACTION z999_lingue('I')
  MENUITEM 'c&Ategories' ACTION z999_catego('I')
  MENUITEM 'cou&Nters'   ACTION z999_progre('I')
  SEPARATOR
  MENUITEM 'All'   ACTION z999_all('I')
 END POPUP
 DEFINE POPUP '&Pack'
  MENUITEM '&Contacts'   ACTION z999_subjec('P')
  MENUITEM '&Mail List'  ACTION z999_mailer('P')
  MENUITEM '&Typologies' ACTION z999_typolo('P')
  MENUITEM '&Languages'  ACTION z999_lingue('P')
  MENUITEM 'c&Ategories' ACTION z999_catego('P')
  MENUITEM 'cou&Nters'   ACTION z999_progre('P')
  SEPARATOR
  MENUITEM 'All'   ACTION z999_all('P')
 END POPUP
 END MENU

 DEFINE STATUSBAR
 STATUSITEM "DbName :" WIDTH 200
 STATUSITEM "User :" WIDTH 150
 CLOCK WIDTH 80
 DATE WIDTH 100
 END STATUSBAR

END WINDOW
CENTER WINDOW z999win
z999_init()
ACTIVATE WINDOW z999win

RETURN NIL

/*
* init maschera
*/
STATIC FUNCTION z999_init()
RETURN NIL

/*
*	ingresso al programma
*/
STATIC FUNCTION z999_login()
*IF l3w_fLogin()==.T. .AND. l3w_fGetperms(z999_cProcName, "x")==.T.
 z999_status()
*ELSE
* z999win.release
*ENDIF
RETURN NIL

/*
*	uscita dal programma
*/
STATIC FUNCTION z999_exit()
z999win.release
RETURN NIL

/*
*	aggiorna campi status bar
*/
STATIC FUNCTION z999_status()
z999win.StatusBar.Item(1) := "DataBase : " + l3w_fConf("DataBase", "Description")
z999win.StatusBar.Item(2) := "User : " + l3w_fConf("User", "Name")
RETURN NIL

/*
* Progressivi
*/
STATIC FUNCTION z999_progre(cType)
IF cType=="D"
 z999_CrtDbf("progress")
ELSEIF cType=="I"
 z999_CrtIdx("progress")
ELSEIF cType=="P"
 z999_Packed("progress")
ENDIF
RETURN NIL

/*
* Lingue
*/
STATIC FUNCTION z999_lingue(cType)
IF cType=="D"
 z999_CrtDbf("language")
ELSEIF cType=="I"
 z999_CrtIdx("language")
ELSEIF cType=="P"
 z999_Packed("language")
ENDIF
RETURN NIL

/*
* Categorie
*/
STATIC FUNCTION z999_catego(cType)
IF cType=="D"
 z999_CrtDbf("category")
ELSEIF cType=="I"
 z999_CrtIdx("category")
ELSEIF cType=="P"
 z999_Packed("category")
ENDIF
RETURN NIL

/*
* Tipologie
*/
STATIC FUNCTION z999_typolo(cType)
IF cType=="D"
 z999_CrtDbf("typology")
ELSEIF cType=="I"
 z999_CrtIdx("typology")
ELSEIF cType=="P"
 z999_Packed("typology")
ENDIF
RETURN NIL

/*
* Mailers
*/
STATIC FUNCTION z999_mailer(cType)
IF cType=="D"
 z999_CrtDbf("maillist")
ELSEIF cType=="I"
 z999_CrtIdx("maillist")
ELSEIF cType=="P"
 z999_Packed("maillist")
ENDIF
RETURN NIL

/*
* Movimenti
*/
STATIC FUNCTION z999_subjec(cType)
IF cType=="D"
 z999_CrtDbf("contacts")
 z999_CrtDbf("postaddr")
 z999_CrtDbf("mailaddr")
 z999_CrtDbf("teleaddr")
 z999_CrtDbf("mailings")
ELSEIF cType=="I"
 z999_CrtIdx("contacts")
 z999_CrtIdx("postaddr")
 z999_CrtIdx("mailaddr")
 z999_CrtIdx("teleaddr")
 z999_CrtIdx("mailings")
ELSEIF cType=="P"
 z999_Packed("contacts")
 z999_Packed("postaddr")
 z999_Packed("mailaddr")
 z999_Packed("teleaddr")
 z999_Packed("mailings")
ENDIF
RETURN NIL

/*
*	Richiesto per tutti
*/
STATIC FUNCTION z999_all(cType)
z999_progre(cType)
z999_lingue(cType)
z999_catego(cType)
z999_typolo(cType)
z999_mailer(cType)
z999_subjec(cType)
RETURN NIL

/*
*	Crea DBF
*/
STATIC FUNCTION z999_CrtDbf( cName )
LOCAL cFilename := l3w_fDbfwpath( cName )
IF !FILE(cFilename) .OR. ;
 ( FILE(cFilename) .AND. ;
  MsgYesNo("File " + Hb_OsNewLine() + cFilename + Hb_OsNewLine() + " already exists, continue )", "z999_CrtDbf()", .T.) )
 z999_CrtStru( cName )
ENDIF
RETURN NIL

/*
*	Creazione
*/
STATIC FUNCTION z999_CrtStru( cName )
LOCAL aStru := p999_aStru(cName), cFile := "", lProceed := .F.
IF LEN(aStru)>0
 lProceed := .T.
ENDIF

IF lProceed
 cFile := l3w_fDbfwpath( cName )
 IF z999_DeleteFile(cFile)
  DBCREATE(cFile, aStru)
  INKEY(NET_WAIT)
  IF !FILE( cFile)
   MsgStop( cFile + Hb_OsNewLine() + "don't created")
   lProceed := .F.
  ENDIF
 ELSE
  lProceed := .F.
 ENDIF
ENDIF
IF lProceed
  z999_CrtIdx(cName)
  z999_Popola(cName)
ENDIF
RETURN NIL

/*
*	Indicizzazione
*/
STATIC FUNCTION z999_CrtIdx(cName)
LOCAL cFilename := "", cIndexname := ""
* progressive
IF cName == "progress"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("progress", "E")
   progress->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "progres1","progress" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    progress->(DBCREATEINDEX( cIndexname, "prgcodice", {|| prgcodice}, .T. ))
    progress->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "progres2","progress" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    progress->(DBCREATEINDEX( cIndexname, "prgdescri", {|| prgdescri}, .F. ))
    progress->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* category
IF cName == "category"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("category", "E")
   category->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "categor1","category" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    category->(DBCREATEINDEX( cIndexname, "catidcate", {|| catidcate}, .T. ))
    category->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "categor2","category" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    category->(DBCREATEINDEX( cIndexname, "catdescri", {|| catdescri}, .F. ))
    category->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* language
IF cName == "language"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("language", "E")
   language->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "languag1","language" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    language->(DBCREATEINDEX( cIndexname, "lanidlang", {|| lanidlang}, .T. ))
    language->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "languag2","language" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    language->(DBCREATEINDEX( cIndexname, "landescri", {|| landescri}, .F. ))
    language->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* typology
IF cName == "typology"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("typology", "E")
   typology->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "typolog1","typology" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    typology->(DBCREATEINDEX( cIndexname, "typidtypo", {|| typidtypo}, .T. ))
    typology->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "typolog2","typology" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    typology->(DBCREATEINDEX( cIndexname, "typdescri", {|| typdescri}, .F. ))
    typology->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* maillist
IF cName == "maillist"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("maillist", "E")
   maillist->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "maillis1","maillist" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    maillist->(DBCREATEINDEX( cIndexname, "mllidmcod", {|| mllidmcod}, .T. ))
    maillist->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "maillis2","maillist" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    maillist->(DBCREATEINDEX( cIndexname, "mlldescri", {|| mlldescri}, .F. ))
    maillist->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* contacts
IF cName == "contacts"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("contacts", "E")
   contacts->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "contact1","contacts" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    contacts->(DBCREATEINDEX( cIndexname, "conidcont", {|| conidcont}, .T. ))
    contacts->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "contact2","contacts" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    contacts->(DBCREATEINDEX( cIndexname, "conlaname+confiname", {|| conlaname+confiname}, .F. ))
    contacts->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* postaddr
IF cName == "postaddr"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("postaddr", "E")
   postaddr->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "postadd1","postaddr" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    postaddr->(DBCREATEINDEX( cIndexname, "posidcont", {|| posidcont}, .F. ))
    postaddr->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "postadd2","postaddr" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    postaddr->(DBCREATEINDEX( cIndexname, "posdescri", {|| posdescri}, .F. ))
    postaddr->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* mailaddr
IF cName == "mailaddr"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("mailaddr", "E")
   mailaddr->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "mailadd1","mailaddr" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    mailaddr->(DBCREATEINDEX( cIndexname, "emlidcont", {|| emlidcont}, .F. ))
    mailaddr->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "mailadd2","mailaddr" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    mailaddr->(DBCREATEINDEX( cIndexname, "emldescri", {|| emldescri}, .F. ))
    mailaddr->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* teleaddr
IF cName == "teleaddr"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("teleaddr", "E")
   teleaddr->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "teleadd1","teleaddr" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    teleaddr->(DBCREATEINDEX( cIndexname, "telidcont", {|| telidcont}, .F. ))
    teleaddr->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "teleadd2","teleaddr" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    teleaddr->(DBCREATEINDEX( cIndexname, "teldescri", {|| teldescri}, .F. ))
    teleaddr->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

* mailings
IF cName == "mailings"
 cFilename := l3w_fDbfwpath(cName)
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("mailings", "E")
   mailings->(SELECT())
* indice 1
   cIndexname := l3w_fNtxwpath( "mailing1","mailings" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    mailings->(DBCREATEINDEX( cIndexname, "mlsidcont+mlsaddres+mlsidmcod", {|| mlsidcont+mlsaddres+mlsidmcod}, .F. ))
    mailings->(DBCOMMIT())
   ENDIF
* indice 2
   cIndexname := l3w_fNtxwpath( "mailing2","mailings" )
   IF z999_DeleteFile(cIndexname)==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "it's impossible to create index")
   ELSE
    mailings->(DBCREATEINDEX( cIndexname, "mlsaddres+mlsidmcod+mlsidcont", {|| mlsaddres+mlsidmcod+mlsidcont}, .F. ))
    mailings->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF

DBUNLOCKALL()
DBCLOSEALL()
RETURN NIL

/*
* Questa procedura rimuove il file
*/
STATIC FUNCTION z999_DeleteFile(cName)
LOCAL lRetvalue := .T.
IF FILE(cName) .AND. FERASE(cName)!=0
 MsgStop( cName + Hb_OsNewLine() + "can't remove")
 lRetvalue := .F.
ENDIF
RETURN lRetvalue

/*
*	questa funzione popola archivi
*/
STATIC FUNCTION z999_Popola(cName)
LOCAL cFilename := "", cIndexname := ""
IF cName == "progress"
 cFilename := l3w_fDbfwpath( cName )
 IF !FILE(cFilename)
  MsgStop(cFilename + Hb_OsNewLine() + "don't exists")
 ELSE
  IF l3w_fNetuse("progress", "E", {"progres1","progres2"})
   progress->(SELECT())
   progress->(ORDSETFOCUS(1))
   IF l3w_fAddrec("progress")==.F.
    MsgStop(cFilename + Hb_OsNewLine() + "Can't add records", "z999_Popola()")
   ELSE
    progress->adminproc := z999_cProcName
    progress->adminuser := l3w_fConf("User", "Login")
    progress->admintstp := HB_TTOS( HB_DATETIME() )
    progress->prgcodice := "LSUBJECT"
    progress->prgdescri := "Ultimo soggetto"
    progress->prgnumero := 0
    progress->(DBCOMMIT())
   ENDIF
  ENDIF
 ENDIF
ENDIF
DBUNLOCKALL()
DBCLOSEALL()
RETURN

/*
*	Compattazione
*/
STATIC FUNCTION z999_packed(cName)
LOCAL lReturn := .F.
IF cName == "progress" .AND. l3w_fNetuse("progress", "E", {"progres1","progres2"})
 progress->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "category" .AND. l3w_fNetuse("category", "E", {"categor1","categor2"})
 category->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "language" .AND. l3w_fNetuse("language", "E", {"languag1","languag2"})
 language->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "typology" .AND. l3w_fNetuse("typology", "E", {"typolog1","typolog2"})
 typology->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "maillist" .AND. l3w_fNetuse("maillist", "E", {"maillis1","maillis2"})
 maillist->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "contacts" .AND. l3w_fNetuse("contacts", "E", {"contact1","contact2"})
 contacts->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "postaddr" .AND. l3w_fNetuse("postaddr", "E", {"postadd1","postadd2"})
 postaddr->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "mailaddr" .AND. l3w_fNetuse("mailaddr", "E", {"mailadd1","mailadd2"})
 mailaddr->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "teleaddr" .AND. l3w_fNetuse("teleaddr", "E", {"teleadd1","teleadd2"})
 teleaddr->(__dbPack())
 lReturn := .T.
ENDIF

IF cName == "mailings" .AND. l3w_fNetuse("mailings", "E", {"mailing1","mailing2"})
 mailings->(__dbPack())
 lReturn := .T.
ENDIF

IF lReturn==.F.
 MsgStop("Impossibile compattare :" + Hb_OsNewLine() + cName)
ENDIF

DBUNLOCKALL()
DBCLOSEALL()
RETURN NIL
