/*
*  Contacts Manager
* Release Story board
* v. 0.0.1 : beta release
*/
#include "hconp000.ch"

* about
*      hconp001.prg
* progressive
*      hconp002.prg
*      hconp003.prg
* category
*      hconp004.prg
*      hconp005.prg
* language
*      hconp006.prg
*      hconp007.prg
* typology
*      hconp008.prg
*      hconp009.prg
* mailinglist
*      hconp010.prg
*      hconp011.prg
* contacts
*      hconp100.prg
*      hconp102.prg
*      hconp103.prg
*      hconp104.prg
*      hconp105.prg
*      hconp106.prg
* utility
*      hconp999.prg

FUNCTION main( ... )

IF ! l3w_fSetsys( Hb_AParams() )
 QUIT
ENDIF

p000_Main()

DBUNLOCKALL()
DBCLOSEALL()
RETURN NIL

/****************************************************************
* Main function
****************************************************************/
STATIC FUNCTION p000_Main()

l3w_fConf("Application", "Version",  "0.0.1")

p000_Define()
p001_Define()
p002_Define()
p003_Define()
p004_Define()
p005_Define()
p006_Define()
p007_Define()
p008_Define()
p009_Define()
p010_Define()
p011_Define()
p100_Define()
p102_Define()
p103_Define()
p104_Define()
p105_Define()
p106_Define()
p107_Define()

ACTIVATE WINDOW ALL
RETURN NIL

/****************************************************************
* some form dimensions
* 1024x768, 1020x765, 996x747, 992x744, 988x741, 980x735, 940x705, 900x675
* 860x645, 820x615, 780x585, 750x555, 700x525, 660x495, 620x465, 580x435, 540x405
****************************************************************/
STATIC FUNCTION p000_Define()
SET NAVIGATION EXTENDED
DEFINE WINDOW p000win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 980 ;
 HEIGHT 735 ;
 TITLE l3w_fConf("Application", "Title") + " (v. " + l3w_fConf("Application", "Version") + ") :: " + l3w_fMsg("Form", "FRM000") + " (hconp000)" ;
 WINDOWTYPE MAIN ;
 ICON 'L3W_L3WICO' ;
 ON INIT p000_Init() ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE MAIN MENU
  DEFINE POPUP l3w_fMsg("Menu", "MNU001")
   MENUITEM l3w_fMsg("Menu", "MNU002") ACTION p000_exit()
  END POPUP
  DEFINE POPUP l3w_fMsg("Menu", "MNU011")
   MENUITEM l3w_fMsg("Menu", "MNU012") ACTION p100_Main({"p000win"})
   MENUITEM l3w_fMsg("Menu", "MNU013") ACTION p107_Main({"p000win"})
  END POPUP
  DEFINE POPUP l3w_fMsg("Menu", "MNU003")
   MENUITEM l3w_fMsg("Menu", "MNU010")      ACTION p010_Main({"p000win"})
   MENUITEM l3w_fMsg("Menu", "MNU009")      ACTION p008_Main({"p000win"})
   MENUITEM l3w_fMsg("Menu", "MNU008")      ACTION p006_Main({"p000win"})
   MENUITEM l3w_fMsg("Menu", "MNU007")      ACTION p004_Main({"p000win"})
   MENUITEM l3w_fMsg("Menu", "MNU004")      ACTION p002_Main({"p000win"})
  END POPUP
  DEFINE POPUP l3w_fMsg("Menu", "MNU005")
   MENUITEM l3w_fMsg("Menu", "MNU006")               ACTION p001_Main()
  END POPUP
 END MENU

 DEFINE STATUSBAR
  STATUSITEM "DbName :" WIDTH 250
  STATUSITEM "User :" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR
END WINDOW
p000win.Center
RETURN NIL

/****************************************************************
* Entry function
****************************************************************/
STATIC FUNCTION p000_Init()
IF l3w_fLogin() .AND. l3w_fGetperms("hconp000", "x") .AND. p999_OpenDb()
 p000_Status()
ELSE
 ReleaseAllWindows()
ENDIF
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p000_Exit()
ReleaseAllWindows()
RETURN NIL

/****************************************************************
* Staus bar update
****************************************************************/
STATIC FUNCTION p000_Status()
p000win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p000win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
RETURN NIL
