****************************************************************
*
* About program
*
****************************************************************
#include "hconp000.ch"

/****************************************************************
* define form
****************************************************************/
FUNCTION p001_Define()
SET NAVIGATION EXTENDED
DEFINE WINDOW p001win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 900 ;
 HEIGHT 675 ;
 TITLE l3w_fMsg("Form", "FRM001") + " (hconp001)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p001_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("FormFont", "Name") ;
  SIZE VAL(l3w_fConf("FormFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION 'e&Xit' ;
   PICTURE "L3W_IEXIT" ;
   ACTION p001_Exit() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p001win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

 DEFINE LABEL lb_apptitle1
  PARENT p001win
  ROW 60
  COL 20
  VALUE "Title"
  WIDTH 150
  HEIGHT 25
  ALIGNMENT Left
  FONTBOLD .T.
 END LABEL
 DEFINE LABEL lb_apptitle
  PARENT p001win
  ROW 60
  COL 175
  VALUE l3w_fConf("Application", "Title")
  WIDTH 440
  HEIGHT 25
  ALIGNMENT Left
 END LABEL

 DEFINE LABEL lb_appver1
  PARENT p001win
  ROW 90
  COL 20
  VALUE "Version"
  WIDTH 150
  HEIGHT 25
  ALIGNMENT Left
  FONTBOLD .T.
 END LABEL
 DEFINE LABEL lb_appver
  PARENT p001win
  ROW 90
  COL 175
  VALUE l3w_fConf("Application", "Version")
  WIDTH 440
  HEIGHT 25
  ALIGNMENT Left
 END LABEL

 DEFINE LABEL lb_authname1
  PARENT p001win
  ROW 120
  COL 20
  VALUE "Author"
  WIDTH 150
  HEIGHT 25
  ALIGNMENT Left
  FONTBOLD .T.
 END LABEL
 DEFINE LABEL lb_authname
  PARENT p001win
  ROW 120
  COL 175
  VALUE "Luigi Ferraris - Italy"
  WIDTH 440
  HEIGHT 25
  ALIGNMENT Left
 END LABEL

 DEFINE LABEL lb_httpname1
  PARENT p001win
  ROW 150
  COL 20
  VALUE "Web site"
  WIDTH 150
  HEIGHT 25
  ALIGNMENT Left
  FONTBOLD .T.
 END LABEL
 DEFINE HYPERLINK httpname
  PARENT p001win
  ROW 150
  COL 175
  WIDTH 440
  HEIGHT 25
  VALUE "www.L3W.it"
  ADDRESS "http://www.L3W.it"
  HANDCURSOR .T.
  ALIGNMENT Left
 END HYPERLINK
END WINDOW
p001win.Center
RETURN NIL

/****************************************************************
* Entry function
****************************************************************/
FUNCTION p001_Main()
LOCAL lReturn := .F.
IF l3w_fGetperms("hconp001", "x")
 lReturn := .T.
 p001_ShowForm()
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p001_ShowForm()
IF l3w_fGetperms("hconp001", "x")
 p001win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
 p001win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
 p001win.Restore
 p001win.Setfocus
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p001_IntClose()
p001_ResetStatus()
p001win.Hide
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p001_Exit()
p001_ResetStatus()
p001win.Hide
RETURN NIL
/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p001_ResetStatus()
p001win.FormStatus.Value := "N"
RETURN NIL
