/****************************************************************
* manager of table contacts
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p102_Define()
LOCAL aStatdes := p999_aStatus("D")
LOCAL aGrdMail1 := {"TEXTBOX", "NUMERIC", "99999999", "99999999"}
LOCAL aGrdMail2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail3 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail4 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail5 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail6 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail7 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail8 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail9 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p102win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM102")+" (hconp102)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p102_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p102_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD002") ;
   PICTURE "L3W_ISAVE" ;
   ACTION p102_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p102win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field conidcont disabled
 DEFINE LABEL lb_conidcont
  PARENT p102win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL001")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX conidcont
  PARENT p102win
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* field constatus
 DEFINE LABEL lb_constatus
  PARENT p102win
  ROW 60
  COL 250
  VALUE l3w_fMsg("Label", "LBL006")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_constatus
  PARENT p102win
  ROW 60
  COL 355
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field conlaname
 DEFINE LABEL lb_conlaname
  PARENT p102win
  ROW 90
  COL 20
  VALUE l3w_fMsg("Label", "LBL007")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX conlaname
  PARENT p102win
  ROW 90
  COL 125
  WIDTH 300
  HEIGHT 25
  MAXLENGTH p999_LenField("contacts","conlaname")
  ONENTER p102_conlaname()
  TOOLTIP l3w_fMsg("ToolTip", "TTI007")
 END TEXTBOX

* field confiname
 DEFINE LABEL lb_confiname
  PARENT p102win
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL008")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX confiname
  PARENT p102win
  ROW 120
  COL 125
  WIDTH 300
  HEIGHT 25
  MAXLENGTH p999_LenField("contacts","confiname")
  ONENTER p102_confiname()
  TOOLTIP l3w_fMsg("ToolTip", "TTI008")
 END TEXTBOX

* field connkname
 DEFINE LABEL lb_connkname
  PARENT p102win
  ROW 150
  COL 20
  VALUE l3w_fMsg("Label", "LBL009")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX connkname
  PARENT p102win
  ROW 150
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("contacts","connkname")
  TOOLTIP l3w_fMsg("ToolTip", "TTI009")
 END TEXTBOX

* field concatego
 DEFINE LABEL lb_concatego
  PARENT p102win
  ROW 180
  COL 20
  VALUE l3w_fMsg("Label", "LBL010")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX concatego
  PARENT p102win
  ROW 180
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI010")
  MAXLENGTH p999_LenField("contacts","concatego")
  CASECONVERT UPPER
  ONENTER p102_concatego()
 END TEXTBOX
* button bt_src_concatego
 DEFINE BUTTON bt_src_concatego
  PARENT p102win
  ROW 180
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p102_src_concatego()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
 DEFINE TEXTBOX catdescri
  PARENT p102win
  ROW 180
  COL 265
  HEIGHT 25
  WIDTH 300
  MAXLENGTH p999_LenField("category","catdescri")
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* field conlangua
 DEFINE LABEL lb_conlangua
  PARENT p102win
  ROW 210
  COL 20
  VALUE l3w_fMsg("Label", "LBL011")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX conlangua
  PARENT p102win
  ROW 210
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI011")
  MAXLENGTH p999_LenField("contacts","conlangua")
  CASECONVERT UPPER
  ONENTER p102_conlangua()
 END TEXTBOX
* button bt_src_conlangua
 DEFINE BUTTON bt_src_conlangua
  PARENT p102win
  ROW 210
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p102_src_conlangua()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
 DEFINE TEXTBOX landescri
  PARENT p102win
  ROW 210
  COL 265
  HEIGHT 25
  WIDTH 300
  MAXLENGTH p999_LenField("language","landescri")
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* area gridmail
 DEFINE LABEL lb_gridmail
  PARENT p102win
  ROW 270
  COL 05
  VALUE l3w_fMsg("Label", "LBL012")
  WIDTH 300
  HEIGHT 25
  FONTSIZE 14
  FONTBOLD .T.
  FONTCOLOR {0,0,0}
  BACKCOLOR {197,217,241}
  ALIGNMENT Center
 END LABEL
* grid definition
 DEFINE GRID gridmail
  PARENT p102win
  ROW 300
  COL 05
  WIDTH 300
  HEIGHT 200
  HEADERS {'Rec.N.','Status','Type','Short Descr.','e-mail'}
  WIDTHS {0,60,60,200,0}
  ONDBLCLICK p102_EditMail()
  COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3, aGrdMail4, aGrdMail5}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
 END GRID

* MailingList grid definition: ATTENTION: it's hidden
 DEFINE GRID gridmlst
  PARENT p102win
  ROW 530
  COL 05
  WIDTH 300
  HEIGHT 100
  HEADERS {'Rec.N.','Status','e-mail','Mail List'}
  WIDTHS {80,80,80,80}
  COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3, aGrdMail4}
  VISIBLE .F.
 END GRID

* area gridphon
 DEFINE LABEL lb_gridphon
  PARENT p102win
  ROW 270
  COL 310
  VALUE l3w_fMsg("Label", "LBL015")
  WIDTH 300
  HEIGHT 25
  FONTSIZE 14
  FONTBOLD .T.
  FONTCOLOR {0,0,0}
  BACKCOLOR {197,217,241}
  ALIGNMENT Center
 END LABEL
* grid definition
 DEFINE GRID gridphon
  PARENT p102win
  ROW 300
  COL 310
  WIDTH 300
  HEIGHT 200
  HEADERS {'Rec.N.','Status','Type','Short Descr.','phone'}
  WIDTHS {0,60,60,200,0}
  ONDBLCLICK p102_EditPhone()
  COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3, aGrdMail4, aGrdMail5}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
 END GRID

* area gridphon
 DEFINE LABEL lb_gridpost
  PARENT p102win
  ROW 270
  COL 615
  VALUE l3w_fMsg("Label", "LBL017")
  WIDTH 300
  HEIGHT 25
  FONTSIZE 14
  FONTBOLD .T.
  FONTCOLOR {0,0,0}
  BACKCOLOR {197,217,241}
  ALIGNMENT Center
 END LABEL
* grid definition
 DEFINE GRID gridpost
  PARENT p102win
  ROW 300
  COL 615
  WIDTH 300
  HEIGHT 200
  HEADERS {'Rec.N.','Status','Type','Short Descr.','addr1','addr2','addr3','addr4','addr5'}
  WIDTHS {0,60,60,200,0,0,0,0,0}
  ONDBLCLICK p102_EditPost()
  COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3, aGrdMail4, aGrdMail5, aGrdMail6, aGrdMail7, aGrdMail8, aGrdMail9}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
 END GRID

END WINDOW
p102win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p102_Main(aParm, nGrid)
LOCAL lReturn := .F.
PUBLIC p102_cProcname := "hconp102"
nGrid := IIF(VALTYPE(nGrid)=="N", nGrid, 0)
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p102_cProcname, "x" ) .AND. l3w_fFomFree( "p102win", "FormStatus", "N" )
 lReturn := .T.
 p102_ShowForm(aParm, nGrid)
ELSE
 p102_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
* _nRecStatus = -1 No action taken
* _nRecStatus = 0 Record Not Found
* _nRecStatus = 1 Record Found and Locked
* _nRecStatus = 2 Record already deleted
* _nRecStatus = 3 (2+1) Record found and locked but already deleted
****************************************************************/
STATIC FUNCTION p102_ShowForm(aParm, nGrid)
PUBLIC p102_nRecStatus := -1, p102_lOnChange := .F.
PUBLIC p102_aParm := aParm, p102_nGrid := nGrid
p102win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p102win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p102win.Restore
p102win.SetFocus
p102_FormReset()
p102_Enter()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p102_aParm is declared PUBLIC inside in p102_ShowForm function
* but p102_NewFocus can be called from p102_Main and p102_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p102_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p102_aParm"), __MVGET("p102_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p102_aParm")
 __MVPUT("p102_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* InteractiveClose function
****************************************************************/
STATIC FUNCTION p102_IntClose()
p102_FormReset()
p102_StatusReset()
p102_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p102_Exit()
p102_FormReset()
p102_StatusReset()
p102win.Hide
p102_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p102_Save()
IF l3w_fGetperms( p102_cProcname, "w" ) .AND. p102_CheckData()
 IF p102_Update()
  p102_FormReset()
  p102_StatusReset()
  p102win.Hide
  p102_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p102_Reset()
p102_FormReset()
p102_StatusReset()
p102win.Hide
p102_NewFocus()
RETURN NIL

/****************************************************************
* Edit Mail Grid
****************************************************************/
STATIC FUNCTION p102_EditMail()
LOCAL lReturn := p103_Main({"p102win","gridmail","gridmail"}, p102win.gridmail.Value)
RETURN NIL

/****************************************************************
* Edit Phone Grid
****************************************************************/
STATIC FUNCTION p102_EditPhone()
LOCAL lReturn := p104_Main({"p102win","gridphon","gridphon"}, p102win.gridphon.Value)
RETURN NIL

/****************************************************************
* Edit Postal Grid
****************************************************************/
STATIC FUNCTION p102_EditPost()
LOCAL lReturn := p105_Main({"p102win","gridpost","gridpost"}, p102win.gridpost.Value)
RETURN NIL

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p102_Enter()
LOCAL aTemp := {}
* if Record Numer is 0 I must Append
IF p102_nGrid==0
 p102win.conidcont.Value := REPLICATE("9", p999_LenField("contacts","conidcont"))
ELSE
 aTemp := GetProperty( "p100win", "gridfiltro", "item", p102_nGrid)
 p102win.conidcont.Value := aTemp[2]
ENDIF
p102_Getrec()
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p102_StatusReset()
IF p102_nRecStatus<>-1
 contacts->(DBUNLOCKALL())
 postaddr->(DBUNLOCKALL())
 mailaddr->(DBUNLOCKALL())
 teleaddr->(DBUNLOCKALL())
 mailings->(DBUNLOCKALL())
ENDIF
p102_nRecStatus := -1
p102win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p102_FormReset()
p102win.cb_constatus.Value := 1
p102win.conidcont.Value := ""
p102win.conlaname.Value := ""
p102win.confiname.Value := ""
p102win.connkname.Value := ""
p102win.concatego.Value := ""
p102win.catdescri.Value := ""
p102win.conlangua.Value := ""
p102win.landescri.Value := ""

p102win.gridmail.DeleteAllItems
p102win.gridmlst.DeleteAllItems
p102win.gridphon.DeleteAllItems
p102win.gridpost.DeleteAllItems

* in HM 3.0.32 there was a problem with VISIBLE .F. on grid: for this reason I've addedd this line
p102win.gridmlst.Hide

p102win.cb_constatus.SetFocus

p102win.bt_save.Enabled := .F.
RETURN NIL

/****************************************************************
* Retrieve record function
****************************************************************/
STATIC FUNCTION p102_Getrec()
LOCAL cKey := l3w_fFiller(p102win.conidcont.Value, p999_LenField("contacts","conidcont"))
contacts->(ORDSETFOCUS(1))
p102_nRecStatus := 0
IF contacts->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("contacts")==.T.
  p102_nRecStatus := 1
  IF contacts->(DELETED())
   p102_nRecStatus := 3
  ENDIF
  p102_LoadForm()
 ELSE
 MsgStop(l3w_fMsg("Error", "ERR003"), "p102_Getrec()")
 ENDIF
ELSE
 p102_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p102_LoadForm()
LOCAL aGetdes := {}
p102win.FormStatus.Value := "I"
IF p102_nRecStatus<>0
 p102win.conidcont.Value := contacts->conidcont
 p102win.cb_constatus.Value := p999_StatusByCod(contacts->constatus)
 p102win.conlaname.Value := contacts->conlaname
 p102win.confiname.Value := contacts->confiname
 p102win.connkname.Value := contacts->connkname
 p102win.concatego.Value := contacts->concatego
 aGetdes := p004_Getdes(p102win.concatego.Value)
 p102win.catdescri.Value := aGetdes[2]
 p102win.conlangua.Value := contacts->conlangua
 aGetdes := p006_Getdes(p102win.conlangua.Value)
 p102win.landescri.Value := aGetdes[2]
 p102_LoadMail()
 p102_LoadPhone()
 p102_LoadPost()
ENDIF

p102win.bt_save.Enabled := .T.
RETURN NIL

/****************************************************************
* Load Mail
****************************************************************/
STATIC FUNCTION p102_LoadMail()
LOCAL cKey := l3w_fFiller(p102win.conidcont.Value, p999_LenField("mailaddr","emlidcont"))
mailaddr->(ORDSETFOCUS(1))
mailaddr->(DBSEEK(cKey, .T.))
DO WHILE !mailaddr->(EOF()) .AND. mailaddr->emlidcont==cKey
 p102win.gridmail.AddItem( {mailaddr->(RECNO()), mailaddr->emlstatus, mailaddr->emltypolo, mailaddr->emldescri, mailaddr->emladdres })
 mailaddr->(DBSKIP(+1))
ENDDO

* mailing list
mailings->(ORDSETFOCUS(1))
mailings->(DBSEEK(cKey, .T.))
DO WHILE !mailings->(EOF()) .AND. mailings->mlsidcont==cKey
 p102win.gridmlst.AddItem( {mailings->(RECNO()), mailings->mlsstatus, mailings->mlsaddres, mailings->mlsidmcod })
 mailings->(DBSKIP(+1))
ENDDO
RETURN NIL

/****************************************************************
* Load Phone
****************************************************************/
STATIC FUNCTION p102_LoadPhone()
LOCAL cKey := l3w_fFiller(p102win.conidcont.Value, p999_LenField("teleaddr","telidcont"))
teleaddr->(ORDSETFOCUS(1))
teleaddr->(DBSEEK(cKey, .T.))
DO WHILE !teleaddr->(EOF()) .AND. teleaddr->telidcont==cKey
 p102win.gridphon.AddItem( {teleaddr->(RECNO()), teleaddr->telstatus, teleaddr->teltypolo, teleaddr->teldescri, teleaddr->teladdres })
 teleaddr->(DBSKIP(+1))
ENDDO
RETURN NIL

/****************************************************************
* Load Postal
****************************************************************/
STATIC FUNCTION p102_LoadPost()
LOCAL cKey := l3w_fFiller(p102win.conidcont.Value, p999_LenField("postaddr","posidcont"))
postaddr->(ORDSETFOCUS(1))
postaddr->(DBSEEK(cKey, .T.))
DO WHILE !postaddr->(EOF()) .AND. postaddr->posidcont==cKey
 p102win.gridpost.AddItem( {postaddr->(RECNO()), postaddr->posstatus, postaddr->postypolo, postaddr->posdescri, postaddr->posaddrl1, postaddr->posaddrl2, postaddr->posaddrl3, postaddr->posaddrl4, postaddr->posaddrl5 })
 postaddr->(DBSKIP(+1))
ENDDO
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p102_Update()
LOCAL lDone := .T., lRiattiva := .F.
LOCAL nValore := 0
IF p102_nRecStatus==0
 IF p002_getprogr("LSUBJECT", @nValore, p102_cProcname)==.T.
  p102win.conidcont.Value := STRZERO(nValore, 8)
  IF l3w_fAddrec("contacts")==.F.
   MsgStop(l3w_fMsg("Error", "ERR004"),"p102_update()")
   lDone:=.F.
  ENDIF
 ELSE
  lDone:=.F.
  MsgStop(l3w_fMsg("Error", "ERR008") + "LSUBJECT","p102_update()")
 ENDIF
ENDIF
IF p102_nRecStatus==3
 lRiattiva := MsgYesNo(l3w_fMsg("Message", "MSG001"),"p102_update()")
ENDIF
IF lDone == .T.
 contacts->adminproc := p102_cProcname
 contacts->adminuser := l3w_fConf("User", "Login")
 contacts->admintstp := HB_TTOS( HB_DATETIME() )
 contacts->conidcont := ALLTRIM(p102win.conidcont.Value)
 contacts->constatus := p999_StatusByNum(p102win.cb_constatus.Value)
 contacts->conlaname := ALLTRIM(p102win.conlaname.Value)
 contacts->confiname := ALLTRIM(p102win.confiname.Value)
 contacts->connkname := ALLTRIM(p102win.connkname.Value)
 contacts->concatego := ALLTRIM(p102win.concatego.Value)
 contacts->conlangua := ALLTRIM(p102win.conlangua.Value)
 IF p102_nRecStatus==3 .AND. lRiattiva==.T.
  contacts->(DBRECALL())
 ENDIF
 p102_UpdMail()
 p102_UpdPhone()
 p102_UpdPost()
 p102_UpdGridP100()
 contacts->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Update data mailaddr
****************************************************************/
STATIC FUNCTION p102_UpdMail()
LOCAL nI := 0, aTemp := {}, lProceed := .F., aEmailDisabled := {}, nX := 0, cMailStatus := ""
FOR nI := 1 TO p102win.gridmail.ItemCount
 aTemp := p102win.gridmail.Item(nI)
 lProceed := .F.
* if Record Numer is 0 I must Append
 IF aTemp[1]==0
  IF l3w_fAddrec("mailaddr") == .T.
   lProceed := .T.
  ENDIF
 ELSE
  mailaddr->(DBGOTO(aTemp[1]))
  IF l3w_fReclock("mailaddr") == .T.
   lProceed := .T.
  ENDIF
 ENDIF
* Can I proceed?
 IF lProceed == .T.
  mailaddr->adminproc := p102_cProcname
  mailaddr->adminuser := l3w_fConf("User", "Login")
  mailaddr->admintstp := HB_TTOS( HB_DATETIME() )
  mailaddr->emlidcont := p102win.conidcont.Value
* if contacts is disabled, mail will be disabled
  mailaddr->emlstatus := IIF(p999_StatusByNum(p102win.cb_constatus.Value)=="D", "D", aTemp[2])
  mailaddr->emltypolo := aTemp[3]
  mailaddr->emldescri := aTemp[4]
  mailaddr->emladdres := aTemp[5]
* remember email address disabled
  IF mailaddr->emlstatus == "D"
   AADD(aEmailDisabled, ALLTRIM(mailaddr->emladdres))
  ENDIF
  mailaddr->(DBCOMMIT())
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR012"), "p102_UpdMail()")
 ENDIF
NEXT nI
* mailings
FOR nI := 1 TO p102win.gridmlst.ItemCount
 aTemp := p102win.gridmlst.Item(nI)
 lProceed := .F.
* if Record Numer is 0 I must Append
 IF aTemp[1]==0
  IF l3w_fAddrec("mailings") == .T.
   lProceed := .T.
  ENDIF
 ELSE
  mailings->(DBGOTO(aTemp[1]))
  IF l3w_fReclock("mailings") == .T.
   lProceed := .T.
  ENDIF
 ENDIF
* Can I proceed?
 IF lProceed == .T.
  nX := ASCAN(aEmailDisabled, ALLTRIM(aTemp[3]))
  cMailStatus := IIF(nX <> 0, "D", "A")
  mailings->adminproc := p102_cProcname
  mailings->adminuser := l3w_fConf("User", "Login")
  mailings->admintstp := HB_TTOS( HB_DATETIME() )
  mailings->mlsidcont := p102win.conidcont.Value
* if mail is disabled, maillist of this address will be disabled
  mailings->mlsstatus := IIF(cMailStatus=="D", "D", aTemp[2])
  mailings->mlsaddres := aTemp[3]
  mailings->mlsidmcod := aTemp[4]
  mailings->(DBCOMMIT())
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR012"), "p102_UpdMail()")
 ENDIF
NEXT nI
RETURN NIL

/****************************************************************
* Update data teleaddr
****************************************************************/
STATIC FUNCTION p102_UpdPhone()
LOCAL nI := 0, aTemp := {}, lProceed := .F.
FOR nI := 1 TO p102win.gridphon.ItemCount
 aTemp := p102win.gridphon.Item(nI)
 lProceed := .F.
* if Record Numer is 0 I must Append
 IF aTemp[1]==0
  IF l3w_fAddrec("teleaddr") == .T.
   lProceed := .T.
  ENDIF
 ELSE
  teleaddr->(DBGOTO(aTemp[1]))
  IF l3w_fReclock("teleaddr") == .T.
   lProceed := .T.
  ENDIF
 ENDIF
* Can I proceed?
 IF lProceed == .T.
  teleaddr->adminproc := p102_cProcname
  teleaddr->adminuser := l3w_fConf("User", "Login")
  teleaddr->admintstp := HB_TTOS( HB_DATETIME() )
  teleaddr->telidcont := p102win.conidcont.Value
  teleaddr->telstatus := IIF(p999_StatusByNum(p102win.cb_constatus.Value)=="D", "D", aTemp[2])
  teleaddr->teltypolo := aTemp[3]
  teleaddr->teldescri := aTemp[4]
  teleaddr->teladdres := aTemp[5]
  teleaddr->(DBCOMMIT())
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR013"), "p102_UpdPhone()")
 ENDIF
NEXT nI
RETURN NIL

/****************************************************************
* Update data postaddr
****************************************************************/
STATIC FUNCTION p102_UpdPost()
LOCAL nI := 0, aTemp := {}, lProceed := .F.
FOR nI := 1 TO p102win.gridpost.ItemCount
 aTemp := p102win.gridpost.Item(nI)
 lProceed := .F.
* if Record Numer is 0 I must Append
 IF aTemp[1]==0
  IF l3w_fAddrec("postaddr") == .T.
   lProceed := .T.
  ENDIF
 ELSE
  postaddr->(DBGOTO(aTemp[1]))
  IF l3w_fReclock("postaddr") == .T.
   lProceed := .T.
  ENDIF
 ENDIF
* Can I proceed?
 IF lProceed == .T.
  postaddr->adminproc := p102_cProcname
  postaddr->adminuser := l3w_fConf("User", "Login")
  postaddr->admintstp := HB_TTOS( HB_DATETIME() )
  postaddr->posidcont := p102win.conidcont.Value
  postaddr->posstatus := IIF(p999_StatusByNum(p102win.cb_constatus.Value)=="D", "D", aTemp[2])
  postaddr->postypolo := aTemp[3]
  postaddr->posdescri := aTemp[4]
  postaddr->posaddrl1 := aTemp[5]
  postaddr->posaddrl2 := aTemp[6]
  postaddr->posaddrl3 := aTemp[7]
  postaddr->posaddrl4 := aTemp[8]
  postaddr->posaddrl5 := aTemp[9]
  postaddr->(DBCOMMIT())
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR015"), "p102_UpdPost()")
 ENDIF
NEXT nI
RETURN NIL

/****************************************************************
* Update Data Grid  p100
****************************************************************/
STATIC FUNCTION p102_UpdGridp100()
LOCAL aTemp := {}
IF p102_nGrid==0
 aTemp := {"", "", "", ""}
ELSE
 aTemp := GetProperty( "p100win", "gridfiltro", "item", p102_nGrid)
ENDIF
aTemp[1] := p999_StatusByDes(p102win.cb_constatus.Value)
aTemp[2] := p102win.conidcont.Value
aTemp[3] := p102win.conlaname.Value
aTemp[4] := p102win.confiname.Value
* if Record Numer is 0 I must Append
IF p102_nGrid==0
 DoMethod("p100win", "gridfiltro", "additem", aTemp)
 p102_nGrid := GetProperty("p100win", "gridfiltro", "ItemCount")
 SetProperty("p100win", "gridfiltro", "Value", p102_nGrid )
ELSE
 SetProperty("p100win", "gridfiltro", "item", p102_nGrid, aTemp )
ENDIF
RETURN NIL

/****************************************************************
* Errors check: return .T. if it's all okay
****************************************************************/
STATIC FUNCTION p102_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p102_conidcont(), lItsOk)
lItsOk := IF(lItsOk==.T., p102_conlaname(), lItsOk)
lItsOk := IF(lItsOk==.T., p102_confiname(), lItsOk)
lItsOk := IF(lItsOk==.T., p102_concatego(), lItsOk)
lItsOk := IF(lItsOk==.T., p102_conlangua(), lItsOk)
RETURN lItsOk

/****************************************************************
* error conidcont
****************************************************************/
STATIC FUNCTION p102_conidcont()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p102win.conidcont.Value ) )<>8 .AND. LEN( ALLTRIM( p102win.conidcont.Value ) )<>0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR005"), "p102_conidcont()")
 p102win.conidcont.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* error conlaname
****************************************************************/
STATIC FUNCTION p102_conlaname()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p102win.conlaname.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR006"), "p102_conlaname()")
 p102win.conlaname.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* error confiname
****************************************************************/
STATIC FUNCTION p102_confiname()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p102win.confiname.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR006"), "p102_confiname()")
 p102win.confiname.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* error concatego
****************************************************************/
STATIC FUNCTION p102_concatego()
LOCAL lItsOk := .T.
LOCAL aGetdes := {}
IF p004_Isok(p102win.concatego.Value)==.F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR010"), "p102_concatego()")
 p102win.concatego.SetFocus
ELSE
 aGetdes := p004_Getdes(p102win.concatego.Value)
 p102win.catdescri.Value := aGetdes[2]
ENDIF
RETURN lItsOk
/****************************************************************
* searching concatego
****************************************************************/
STATIC FUNCTION p102_src_concatego()
LOCAL lReturn := p005_main( {"p102win", "concatego", "concatego", "catdescri"}, p102win.concatego.Value )
RETURN NIL

/****************************************************************
* error conlangua
****************************************************************/
STATIC FUNCTION p102_conlangua()
LOCAL lItsOk := .T.
LOCAL aGetdes := {}
IF p006_Isok(p102win.conlangua.Value)==.F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR010"), "p102_conlangua()")
 p102win.conlangua.SetFocus
ELSE
 aGetdes := p006_Getdes(p102win.conlangua.Value)
 p102win.landescri.Value := aGetdes[2]
ENDIF
RETURN lItsOk
/****************************************************************
* searching conlangua
****************************************************************/
STATIC FUNCTION p102_src_conlangua()
LOCAL lReturn := p007_main( {"p102win", "conlangua", "conlangua", "landescri"}, p102win.conlangua.Value )
RETURN NIL

/*****************************************************
* useful functions
*****************************************************/
/*
* check if code exists
*/
FUNCTION p102_Isok(cChiave)
LOCAL p102_lastord := contacts->(ORDSETFOCUS(1))
LOCAL p102_lastrec := contacts->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("contacts","conidcont"))
LOCAL lReturn := .F.
IF LEN(ALLTRIM(cKey))>0
 lReturn := contacts->(DBSEEK(cKey, .F.))
ENDIF
contacts->(DBGOTO(p102_lastrec))
contacts->(ORDSETFOCUS(p102_lastord))
RETURN lReturn

/*
* retrieve datas
*/
FUNCTION p102_Getdes(cChiave)
LOCAL p102_lastord := contacts->(ORDSETFOCUS(1))
LOCAL p102_lastrec := contacts->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("contacts","conidcont"))
LOCAL aReturn := {"","","",""}
IF LEN(ALLTRIM(cKey))>0
 IF contacts->(DBSEEK(cKey, .F.)) == .T.
  aReturn[1] := contacts->constatus
  aReturn[2] := contacts->conlaname
  aReturn[3] := contacts->confiname
  aReturn[4] := contacts->connkname
 ENDIF
ENDIF
contacts->(DBGOTO(p102_lastrec))
contacts->(ORDSETFOCUS(p102_lastord))
RETURN aReturn