/****************************************************************
* manager of table postaddr
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p105_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p105win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM105")+" (hconp105)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p105_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p105_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD011") ;
   PICTURE "L3W_IOK" ;
   ACTION p105_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p105win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field posstatus
 DEFINE LABEL lb_posstatus
  PARENT p105win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL006")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_posstatus
  PARENT p105win
  ROW 60
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field postypolo
 DEFINE LABEL lb_postypolo
  PARENT p105win
  ROW 90
  COL 20
  VALUE l3w_fMsg("Label", "LBL013")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX postypolo
  PARENT p105win
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI013")
  MAXLENGTH p999_LenField("postaddr","postypolo")
  CASECONVERT UPPER
  ONENTER p105_postypolo()
 END TEXTBOX
* button bt_src_postypolo
 DEFINE BUTTON bt_src_postypolo
  PARENT p105win
  ROW 90
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p105_src_postypolo()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
 DEFINE TEXTBOX typdescri
  PARENT p105win
  ROW 90
  COL 265
  HEIGHT 25
  WIDTH 300
  MAXLENGTH p999_LenField("typology","typdescri")
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* field posdescri
 DEFINE LABEL lb_posdescri
  PARENT p105win
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX posdescri
  PARENT p105win
  ROW 120
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("postaddr","posdescri")
  ONENTER p105_posdescri()
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
 END TEXTBOX

* field posaddrl1
 DEFINE LABEL lb_posaddrl1
  PARENT p105win
  ROW 150
  COL 20
  VALUE l3w_fMsg("Label", "LBL018")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX posaddrl1
  PARENT p105win
  ROW 150
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("postaddr","posaddrl1")
  ONENTER p105_posaddrl1()
  TOOLTIP l3w_fMsg("ToolTip", "TTI018")
 END TEXTBOX

* field posaddrl2
 DEFINE LABEL lb_posaddrl2
  PARENT p105win
  ROW 180
  COL 20
  VALUE l3w_fMsg("Label", "LBL018")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX posaddrl2
  PARENT p105win
  ROW 180
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("postaddr","posaddrl2")
  ONENTER p105_posaddrl2()
  TOOLTIP l3w_fMsg("ToolTip", "TTI018")
 END TEXTBOX

* field posaddrl3
 DEFINE LABEL lb_posaddrl3
  PARENT p105win
  ROW 210
  COL 20
  VALUE l3w_fMsg("Label", "LBL018")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX posaddrl3
  PARENT p105win
  ROW 210
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("postaddr","posaddrl3")
  ONENTER p105_posaddrl3()
  TOOLTIP l3w_fMsg("ToolTip", "TTI018")
 END TEXTBOX

* field posaddrl4
 DEFINE LABEL lb_posaddrl4
  PARENT p105win
  ROW 240
  COL 20
  VALUE l3w_fMsg("Label", "LBL018")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX posaddrl4
  PARENT p105win
  ROW 240
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("postaddr","posaddrl4")
  ONENTER p105_posaddrl4()
  TOOLTIP l3w_fMsg("ToolTip", "TTI018")
 END TEXTBOX

* field posaddrl5
 DEFINE LABEL lb_posaddrl5
  PARENT p105win
  ROW 270
  COL 20
  VALUE l3w_fMsg("Label", "LBL018")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX posaddrl5
  PARENT p105win
  ROW 270
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("postaddr","posaddrl5")
  ONENTER p105_posaddrl5()
  TOOLTIP l3w_fMsg("ToolTip", "TTI018")
 END TEXTBOX

END WINDOW
p105win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p105_Main(aParm, nGrid)
LOCAL lReturn := .F.
PUBLIC p105_cProcname := "hconp105"
nGrid := IIF(VALTYPE(nGrid)=="N", nGrid, 0)
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p105_cProcname, "x" ) .AND. l3w_fFomFree( "p105win", "FormStatus", "N" )
 lReturn := .T.
 p105_ShowForm(aParm, nGrid)
ELSE
 p105_NewFocus(aParm)
ENDIF

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p105_ShowForm(aParm, nGrid)
PUBLIC p105_nGrid := nGrid
PUBLIC p105_aParm := aParm
p105win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p105win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p105win.Restore
p105win.SetFocus
p105_FormReset()
p105_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p105_aParm is declared PUBLIC inside in p105_ShowForm function
* but p105_NewFocus can be called from p105_Main and p105_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p105_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p105_aParm"), __MVGET("p105_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p105_aParm")
 __MVPUT("p105_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* InteractiveClose function
****************************************************************/
STATIC FUNCTION p105_IntClose()
p105_FormReset()
p105_StatusReset()
p105_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p105_Exit()
p105_FormReset()
p105_StatusReset()
p105win.Hide
p105_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p105_Save()
IF l3w_fGetperms( p105_cProcname, "w" ) .AND. p105_CheckData()
 IF p105_Update()
  p105_FormReset()
  p105_StatusReset()
  p105win.Hide
  p105_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p105_Reset()
p105_FormReset()
p105_StatusReset()
p105win.Hide
p105_NewFocus()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p105_Delete()
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p105_Undelete()
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p105_StatusReset()
p105win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p105_FormReset()
p105win.cb_posstatus.Value := 1
p105win.postypolo.Value := ""
p105win.typdescri.Value := ""
p105win.posdescri.Value := ""
p105win.posaddrl1.Value := ""
p105win.posaddrl2.Value := ""
p105win.posaddrl3.Value := ""
p105win.posaddrl4.Value := ""
p105win.posaddrl5.Value := ""

p105win.cb_posstatus.SetFocus

p105win.bt_save.Enabled := .F.
RETURN NIL

/****************************************************************
* Load form function
* {ALLTRIM(STR(postaddr->(RECNO()))), postaddr->posstatus, postaddr->postypolo, cDescr }
****************************************************************/
STATIC FUNCTION p105_LoadForm()
LOCAL aReturn := {}
LOCAL aTemp := {}
* commits form video
p105win.FormStatus.Value := "I"
* if Record Numer is 0 I must Append
IF p105_nGrid==0
 p105win.cb_posstatus.Value := 1
ELSE
 aTemp := GetProperty( "p102win", "gridpost", "Item" , p105_nGrid)
 p105win.cb_posstatus.Value := p999_StatusByCod( aTemp[2] )
 p105win.postypolo.Value := aTemp[3]
 p105win.posdescri.Value := aTemp[4]
 p105win.posaddrl1.Value := aTemp[5]
 p105win.posaddrl2.Value := aTemp[6]
 p105win.posaddrl3.Value := aTemp[7]
 p105win.posaddrl4.Value := aTemp[8]
 p105win.posaddrl5.Value := aTemp[9]
ENDIF
* se il codice socio esiste, ritorna i campi
IF LEN( ALLTRIM( p105win.postypolo.Value )) > 0
 aReturn := p008_Getdes(p105win.postypolo.Value)
 p105win.typdescri.Value := aReturn[2]
ENDIF

p105win.bt_save.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p105_update()
LOCAL aTemp := {}
LOCAL aGetdes := p008_Getdes(p105win.postypolo.Value)

* if Record Numer is 0 I must Append
IF p105_nGrid==0
 aTemp := {0, "", "", "", "", "", "", "", ""}
ELSE
 aTemp := GetProperty( "p102win", "gridpost", "Item", p105_nGrid)
ENDIF
aTemp[2] := p999_StatusByNum(p105win.cb_posstatus.Value)
aTemp[3] := p105win.postypolo.Value
aTemp[4] := p105win.posdescri.Value
aTemp[5] := p105win.posaddrl1.Value
aTemp[6] := p105win.posaddrl2.Value
aTemp[7] := p105win.posaddrl3.Value
aTemp[8] := p105win.posaddrl4.Value
aTemp[9] := p105win.posaddrl5.Value
* if Record Numer is 0 I must Append
IF p105_nGrid==0
 DoMethod( "p102win", "gridpost", "AddItem", aTemp )
 p105_nGrid := GetProperty("p102win", "gridpost", "ItemCount")
 SetProperty("p102win", "gridpost", "Value", p105_nGrid )
ELSE
 SetProperty( "p102win", "gridpost", "Item", p105_nGrid, aTemp )
ENDIF
RETURN .T.

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p105_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p105_postypolo(), lItsOk)
lItsOk := IF(lItsOk==.T., p105_posdescri(), lItsOk)
lItsOk := IF(lItsOk==.T., p105_posaddrl1(), lItsOk)
RETURN lItsOk

/*
* error postypolo
*/
STATIC FUNCTION p105_postypolo()
LOCAL lItsOk := .T.
LOCAL aReturn := {}
IF p008_Isok( p105win.postypolo.Value ) == .F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR010"),"p105_CheckData")
 p105win.postypolo.SetFocus
ELSE
 aReturn := p008_Getdes(p105win.postypolo.Value)
 p105win.typdescri.Value := aReturn[2]
ENDIF
RETURN lItsOk
/*
* src1
*/
STATIC FUNCTION p105_src_postypolo()
LOCAL lReturn := p009_main( {"p105win", "postypolo", "postypolo", "typdescri"}, p105win.postypolo.Value )
RETURN NIL

/*
* error posdescri
*/
STATIC FUNCTION p105_posdescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p105win.posdescri.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR006"),"p105_posdescri")
 p105win.posdescri.SetFocus
ENDIF
RETURN lItsOk

/*
* error posaddrl1
*/
STATIC FUNCTION p105_posaddrl1()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p105win.posaddrl1.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR014"),"p105_posaddrl1")
 p105win.posaddrl1.SetFocus
ENDIF
RETURN lItsOk

/*
* error posaddrl2
*/
STATIC FUNCTION p105_posaddrl2()
LOCAL lItsOk := .T.
RETURN lItsOk

/*
* error posaddrl3
*/
STATIC FUNCTION p105_posaddrl3()
LOCAL lItsOk := .T.
RETURN lItsOk

/*
* error posaddrl4
*/
STATIC FUNCTION p105_posaddrl4()
LOCAL lItsOk := .T.
RETURN lItsOk

/*
* error posaddrl5
*/
STATIC FUNCTION p105_posaddrl5()
LOCAL lItsOk := .T.
RETURN lItsOk
